#pragma once

#include "CThingSprite.h"

const int C_THING_ANIM_NONE = 0;
const int C_THING_ANIM_NORMAL = 1;
const int C_THING_ANIM_BOUNCE = 2; //not implemented


class CThingAnim : public CThingSprite
{
public:
     CThingAnim();

     bool SetAnim(char *p_fname, int i_width, int i_height, int i_count);
     virtual void Draw();
     virtual void Think();
     void SetAnimType(int i_type) {m_i_animation_type = i_type;}
     void SetAnimDelay(int i_ms) {m_timer_anim.set_interval(i_ms);}
     void SetFrame(int i_frame) {m_sprite.SetFrame(i_frame);};
     CDXSprite * GetCDXSprite(){return &m_sprite;}
     void SetMaxFrameOfAnim(int i_new) {m_i_max_frame = i_new;}


protected: 

    CDXSprite m_sprite;
    CTimer m_timer_anim;
    int m_i_animation_type;
    int m_i_max_frame;

};