#pragma once
#include "stdafx.h"
#include "CThingList.h"
#include "CTimer.h"

const int C_THING_SPRITE_NONE = 0;

const int C_THING_SPRITE_BOUNCE_AND_DIE = 1;

class CThingSprite : public CThing
{
public:
    CThingSprite(); 
    
    virtual void Draw();
    virtual void Think();
    bool SetImage(char *p_st_name, bool b_white_is_transparent);
    void SetPosition(float f_new_x, float f_new_y);
    void SetSpecial(int i_new);
    void SetText(char *p_new);
    void SetKillTimer(int i_ms);
    void SetAllowAutoDepthSort(bool b_new);
    float GetX(){return m_f_x;}
    float GetY(){return m_f_y;}
    void SetHFlip(bool b_new){m_b_h_flip = b_new;}
    void SetVelocity(float f_new){m_f_vel = f_new;}
    void SetDirection(float f_new) {m_f_dir = f_new;}

protected:
    float m_f_x, m_f_y; //positiom
    double m_f_angle, m_f_scale;
    CDXSurface m_sprite;
    bool m_b_white_is_transparent;
    char m_st_text[256];
    int m_i_special; //special behavior settings
    CTimer m_timer_special;
    CTimer m_timer_die;
    bool m_b_die_timer_active;
    float m_f_special_move; //help me move a graphic around Jamul style
    float m_f_dir, m_f_vel;
    bool m_b_allow_auto_depth_sort;
    bool m_b_h_flip; //if yes, pic will be flipped horizontally
};